// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#ifndef OPTIMIZESCRIPT_H_
#define OPTIMIZESCRIPT_H_

#include <fst/script/arg-packs.h>
#include <fst/script/fst-class.h>
#include "optimize.h"

namespace fst {
namespace script {

// One argpack, three script functions.
typedef args::Package<MutableFstClass *, bool> OptimizeArgs;

template <class Arc>
void Optimize(OptimizeArgs *args) {
  MutableFst<Arc> *fst = args->arg1->GetMutableFst<Arc>();
  Optimize(fst, args->arg2);
}

void Optimize(MutableFstClass *fst, bool compute_props);

template <class Arc>
void OptimizeAcceptor(OptimizeArgs *args) {
  MutableFst<Arc> *fst = args->arg1->GetMutableFst<Arc>();
  OptimizeAcceptor(fst, args->arg2);
}

void OptimizeAcceptor(MutableFstClass *fst, bool compute_props);

template <class Arc>
void OptimizeTransducer(OptimizeArgs *args) {
  MutableFst<Arc> *fst = args->arg1->GetMutableFst<Arc>();
  OptimizeTransducer(fst, args->arg2);
}

void OptimizeTransducer(MutableFstClass *fst, bool compute_props);

}  // namespace script
}  // namespace fst

#endif  // OPTIMIZESCRIPT_H_

