// For general information on the Pynini grammar compilation library, see
// pynini.opengrm.org.

#include "pynini_stringify.h"

namespace fst {
namespace script {

bool PyniniStringify(const FstClass &fst, TokenType token_type,
                     const SymbolTable *symbols, string *str) {
  PyniniStringifyInnerArgs iargs(fst, token_type, symbols, str);
  PyniniStringifyArgs args(iargs);
  Apply<Operation<PyniniStringifyArgs>>("PyniniStringify", fst.ArcType(),
                                        &args);
  return args.retval;
}

REGISTER_FST_OPERATION(PyniniStringify, StdArc, PyniniStringifyArgs);
REGISTER_FST_OPERATION(PyniniStringify, LogArc, PyniniStringifyArgs);
REGISTER_FST_OPERATION(PyniniStringify, Log64Arc, PyniniStringifyArgs);

}  // namespace script
}  // namespace fst

